//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  (c) 2010-present DEMOS plan GmbH.
//
//  This file is part of the package demosplan,
//  for more information see the license file.
//
//  All rights reserved
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

@use 'sass:list';

//  base
//
//  styles for generic elements
//      - html
//      - body
//      - u
//      - p
//      - b, strong
//      - h1.. h6

html,
body {
    margin: 0;
    padding: 0;
    -webkit-overflow-scrolling: auto;
}

html {
    height: 100%; // enables min-height:100% for body
    font-family: $base-font-family;
    font-weight: $base-font-weight;

    //  set the default scroll behavior (applies to #anchor page jumps)
    //  @see https://css-tricks.com/almanac/properties/s/scroll-behavior/
    scroll-behavior: smooth;
}

html.fixtinyfixed {
    &,
    body {
        @include media-query('palm') {
            //  these are due to focus jumping bug in fixed elements on iOs
            //  https://remysharp.com/2012/05/24/issues-with-position-fixed-scrolling-on-ios#focus-jumping
            -webkit-overflow-scrolling: touch !important;
            overflow: auto !important;
            height: 100% !important;
        }
    }
}

body {
    min-height: 100%; // ensures complete display of absolutely positioned flyouts
    background: $dp-color-background-default;
    letter-spacing: $base-letter-spacing;
    outline: none;
}

[v-cloak] {
    display: none;
}

//  These values will not show up in content, but are
//  queried by JavaScript to know which breakpoint is active.
//  Add or remove as many breakpoints as you like.
//  See https://www.lullabot.com/articles/importing-css-breakpoints-into-javascript
@each $breakpoint in $breakpoints-js {

    // Get the name of the breakpoint.
    $alias: list.nth($breakpoint, 1);

    @include media-query($alias) {
        body::before {
            display: none;
            content: '#{$alias}';
        }
    }
}

u {
    text-decoration: underline;
}

p {
    margin: 0 0 $inuit-base-spacing-unit--small;
}

b,
strong {
    font-family: $bold-font-family;
    font-weight: $bold-font-weight;
}

h1,
h2,
h3,
h4,
h5,
h6 {
    font-family: $headings-font-family;
    font-weight: $headings-font-weight;
    margin: 0 0 $inuit-base-spacing-unit--small;
}

h1 {
    @include inuit-font-size($dp-font-size-h1, 1.3);

    font-family: $h1-font-family;
    font-weight: $h1-font-weight;
    color: $h1-color;
}

h2 {
    @include inuit-font-size($dp-font-size-h2, 1.3);

    font-family: $h2-font-family;
    font-weight: $h2-font-weight;
    color: $h2-color;
}

h3 {
    @include inuit-font-size($dp-font-size-h3, 1.4);

    font-family: $h3-font-family;
    font-weight: $h3-font-weight;
    color: $h3-color;
}

h4 {
    @include inuit-font-size($dp-font-size-h4, 1.4);
}

h5 {
    @include inuit-font-size($dp-font-size-h5);
}

h6 {
    @include inuit-font-size($dp-font-size-h6);
}

a {
    color: $dp-color-interactive-default;
    text-decoration: #{$dp-links-textdecoration};

    @if ($transition-nav == true) {
        transition: color #{$transition-speed-style-delay}, background-color #{$transition-speed-style-delay};
    }

    &:hover,
    &:active {
        text-decoration: #{$dp-links-textdecoration-hover};
        color: $dp-color-interactive-hover;
    }
}

// Newer releases of chrome / firefox implement dotted border with text-decoration instead of border
// so instead of updating the whole inuit with its reset just add the fix here
abbr[title] {
    text-decoration: none;
}

table {
    width: 100%;
    margin: 0;
    font-size: $base-font-size;
    border-collapse: collapse;
    border-spacing: 0;
}

// Override browser defaults (`font-weight: bold;` will cause a very bold style with system-ui).
th {
    font-weight: $bold-font-weight;
    font-family: $bold-font-family;
}

// Maybe make this a `divider` component?
hr {
    border: none;
    height: 0;
    border-top: 2px solid $dp-color-border-default;
    margin: $inuit-base-spacing-unit--small auto;
}

//  Screen Reader related
@media braille {
    [aria-hidden='true'] {
        display: none;
    }
}
